
#if !defined(STR_HEADER)
#define STR_HEADER
#endif


#define str_end	0x70000000

typedef bool	BOOL;


class str
{
protected:
	char* string;
	int string_len;
	int mark_last;
	int mark_curr;
	int found;
	BOOL negative_flag;
	BOOL str_mem_allocated;
	BOOL do_not_deallocate;

	int MarkStart();
	int MarkLen();
	void SearchLeft(str*);
	void SearchRight(str*);
	char* AllocateString();

public:

	str();
	str(str&);
	str(char*);
	~str();
	//Set(str&);
	//Set(char*);
	void DoNotDeallocate();
	char* Addr();
	char* ch();
	void KleinSchreibung();
	void C64Schreibung();

	str& operator<<(int);
	str& operator<<(str&);
	str& operator<<(char*);

	str& operator>>(int);
	str& operator>>(str&);
	str& operator>>(char*);

	str& operator<=(int);
	str& operator<=(str&);	
	str& operator<=(char*);
	
	str& operator>=(int);
	str& operator>=(str&);
	str& operator>=(char*);

	void operator=(str&);
	void operator=(char*);
	str& operator!();
	BOOL operator==(str&);
	BOOL operator==(char*);
	str& operator+(str&);
	str& operator+(char*);
};




