// Assembler.cpp: Implementierung der Klasse Assembler.
//
//////////////////////////////////////////////////////////////////////

#define _CRT_SECURE_NO_WARNINGS


//#include "stdafx.h"
#include <stdio.h>
#include <tchar.h>
#include "Assembler.h"
//#include "str.h"
//#include <fstream>
#include <iostream>
//#include <string.h>
//#include "data_to_store.h"



//extern ofstream term;


	bool d_t_s__add_start_end_addresses_to_object_filename = false;

//				Bool-FLAGS
#define		FALSE								0
#define		TRUE								1
#define		UNDEFINED						-1
#define		IGNORE							-2
#define		FORBIDDEN						-3

//				sourcecode-FLAGS
#define		LABEL								1
#define     NUMBER							2
#define		INVALID							8
#define		TABULATOR						9
#define     ENDOFLINE						10
#define		LINEFEED						13
//#define		ENDOFLINE_SHORT				0x0a0d
#define		CROSS								'#'
#define		STAR								'*'
#define		PLUS								'+'
#define		SLASH								'/'
#define		MINUS		  						'-'

#define		LOWER_CHAR						100000//'<'
#define		HIGHER_CHAR						100001//'>'
#define		TURBOASS_LOBYTE_CHAR				'<'
#define		TURBOASS_HIBYTE_CHAR				'>'
/*
#define		LOWER_CHAR						'<'
#define		HIGHER_CHAR						'>'
#define		TURBOASS_LOBYTE_CHAR			100000
#define		TURBOASS_HIBYTE_CHAR			100001
*/
#define		POINT								'.'
#define		COMMA								','
#define		SPACE								32
#define		STRING							'$'
#define		PERCENT							'%'
#define		OPEN_BRACKET					'('
#define		CLOSE_BRACKET					')'
#define		EQUAL								'='
#define		QUOTATION_MARK					'"'
#define		SEMIKOLON						';'
#define		KLAMMERAFFE						'@'
#define		AND								'&'
#define		COLON							':'
#define		EXCLAMATION_MARK				'!'

//				operation-FLAGS
#define		NO_OPERATION					0

//				label.type-FLAGS
#define		ORDINARY_LABEL					1
#define		MNEMONIC							2
#define		CPUINSTRUCTION					2 //=MNEMONIC
#define		RESERVED_LABELS_START		2
#define		INSTRUCTION						3
#define		X_REGISTER						4
#define		Y_REGISTER						5
#define		A_REGISTER						6
#define		RESERVED_LABELS_END			6
#define		VARIABLE							7
#define		LBL_LABEL						8
#define		MACRO_LABEL						9
#define     CONSTANT							10

//				INSTRUCTION-FLAGS
#define     TEXT_INSTR 						0
#define		NULL_INSTR                 1
#define		SHIFT_INSTR                2
#define		WORD_INSTR                 3
#define     RTA_INSTR                  4
#define		BYTE_INSTR                 5
#define		VAR_INSTR                  6
#define		GOTO_INSTR                 7
#define     LBL_INSTR                  8
#define		MACRO_INSTR                9
#define		ENDM_INSTR                 10
#define		BLOCK_INSTR                11
#define     BEND_INSTR                 12
#define		IF_INSTR                   13
#define		IFEQ_INSTR                 14
#define		IFMI_INSTR                 15
#define     IFPL_INSTR                 16
#define		ENDIF_INSTR                17
#define		OFFS_INSTR                 18
#define		EOR_INSTR                  19
#define		END_INSTR                  20
#define		INCLUDE_INSTR              21
#define     SHOWMAC_INSTR              22
#define		HIDEMAC_INSTR              23
#define		PRON_INSTR                 24
#define		PROFF_INSTR                25
#define		MACROCALL_INSTR				26
#define		SETDESTINATION_INSTR			27
#define		DECLARATION_INSTR				28

//				assemblestatus-FLAGS
#define		NEWLINE							1
#define		AWAIT_NUMBER					2
#define		AWAIT_REGISTER             3
#define		AWAIT_X_REGISTER           4
#define		AWAIT_Y_REGISTER           5
#define		AWAIT_CHAR                 6
#define		AWAIT_ENDOFLINE            7
#define		AWAIT_CLOSE_BRACKET        8
#define		AWAIT_EQUAL                9
#define		AWAIT_INSTRUCTION          10
#define		AWAIT_COMMA						11
#define		AWAIT_TEXT						12
#define		AWAIT_LBL_LABEL				13
#define		AWAIT_MACRO_LABEL				14

//				send-FLAGS
#define		NO_SEND							0
#define     WORK_NUMBER						1
#define     STORE_OPERAND              2
#define		IGNORE_SOURCECODE_LINE		3
#define		CHECK_OPERAND					4
#define		BREAK_ASSEMBLING				5
#define		SKIP_IF_BLOCK					6
#define		SWITCH_TO_ASSEMBLE_MODE		7
//				send_2-FLAGS
#define		NEWLINE_RESET              30
#define		RESET								31

//				preprocess-MODES
#define		ASSEMBLE							0
#define		AWAIT_ENDMACRO					1
#define		AWAIT_ENDIF						2

//				ERROR-FLAGS
#define		OK									0
#define		SYNTAX							1
#define		DOUBLE_DEFINITION				2
#define		ILLEGAL_ADDRESSMODE			3
#define		EXTRA_CHARACTERS				4
#define		UNALLOWED_ADDRESSMODE		5
#define		ILLEGAL_SOURCE_CODE			6
#define		BRANCH_OUT_OF_RANGE			7
#define		INVALID_SOURCE_FILE			8
#define		ILLEGAL_MNEMONIC				9
#define		ILLEGAL_PSEUDO_OPERATION	10
#define		UNDEFINED_STATEMENT			11
#define		REGISTER_EXPECTED				12
#define		NO_NUMBER_EXPECTED			13
#define		BRACKET_ERROR					14
#define		LABEL_MISSING					15
#define		PROGRAM							16
#define		ILLEGAL_STRING					17
#define		TOO_MANY_OPERANDS				18
#define		OVERFLOW							19
#define		ASSEMBLER_LABEL_EXPECTED	20
#define		NUMBER_MISSING					21
#define		UNEXPECTED_LINEEND			22
#define		MISSING_OPERAND				23
#define		END_OF_SOURCE_CODE			24
#define		UNSOLVED_IF						25
#define		FILE_WRITE_ERROR				26
#define		NO_MACRO_MARKER_ALLOWED		27
#define		ILLEGAL_MACRO_MARKER			28
#define		MACRO_MARKER_NOT_DEFINED	29
#define		TOO_HIGH_MACRO_AND_INCLUDE_DEPTH	30
#define		TOO_MANY_MACRO_PARAMETERS	31
#define		MACRO_NOT_DEFINED				32
#define		TOO_MANY_BRACKETS_OPENED	33
#define		LABEL_RESERVED					34
#define		TOO_MANY_BLOCKS				35
#define		PHASE_ERROR					36
#define		ILLEGAL_PHASE_FLAG			37
#define		CANNOT_OPEN_FILE			38

//				warning-FLAGS
#define		ENDIF_WITHOUT_IF				1
#define     TURBOASS_NO_LABEL				2
#define		NOT_IMPLEMENTED				3
#define		OPERAND_SIZE_WORD_TAKEN		4
#define		CODE_SUCEEDS_0XFFFF			5
#define		ENDMACRO_WITHOUT_MACRO		6
#define		BEND_WITHOUT_BLOCK			7
#define		LABEL_TOO_LONG				8

//				ADRESSMODES
#define		DIRECT   						6
#define     BRACKET_ZEROPAGE_X         7
#define		BRACKET_ZEROPAGE_Y         8
#define		MEMORY                     1
#define		MEMORY_X_REGISTER          3
#define		MEMORY_Y_REGISTER          5
#define     BRACKET_MEMORY             11
#define		ACCUMULATOR                9
#define		NOTHING                    12
#define		RELATIVE							10
#define		NUMBER_ADDRESSMODES			13

#define		CHECK_ON_LETTER 				(x>='a' && x<='z') || (x>='A' && x<='Z') || x=='_'
#define		CHECK_ON_DIGIT					(x>='0' && x<='9')
#define		STRING_CHAR						(x>= 20 && x<=127) //provis
#define		CHECK_BYTE_BOUNDS(val)		(val >= -128 && val <= 255)
#define		CHECK_WORD_BOUNDS(val)		(val >= -32768 && val <= 0xffff)

#define		OPERAND_STACK_SIZE	16


//*************************************************
//**                                             **
//**                 TABLES                      **
//**                                             **
//*************************************************

char* Assembler::ErrorTable[] =
{
	"ok",
	"syntax",
	"double definition",
	"illegal addressmode",
	"extra characters",
	"addressmode not allowed",
	"illegal source file",
	"branch out of range",
	"invalid source file",
	"illegal mnemonic",
	"illegal pseudo operation",
	"undefined statement",
	"missing register",
	"no number expected",
	"bracket error",
	"missing label",
	"program (bug)",
	"illegal string",
	"too many operands",
	"overflow",
	"assembler label expected",
	"missing number",
	"unexpected end of line",
	"missing operand",
	"end of source code",
	"unsolved if",
	"can't write file",
	"macro marker without macro",
	"illegal macro marker",
	"macro marker not defined",
	"too high macros & includes depth",
	"too many macro parameters",
	"macro not defined",
	"too many brackets opened",
	"label reserved, can't be defined",
	"too many blocks",
	"phase error",
	"phase error, illegal phase flag",
	"cannot open file"
};

char* Assembler::WarningTable[] =
{
	"ok",
	"endif without if",
	"turbo ass, no label",
	"not implemented",
	"operand size 'word' taken",
	"code suceeds $ffff, file cut",
	"endmacro without macro",
	"bend without block",
	"label too long; label cut"
};

char* Assembler::endif_string = ".endif";
char* Assembler::endmacro_string = ".endm";


Assembler::Label Assembler::k128 = { 0,0,0,0,0,0,"" };
Assembler::Label Assembler::k127 = { &k128, INSTRUCTION ,0, OFFS_INSTR ,0,4, "offs" };
Assembler::Label Assembler::k126 = { &k127, INSTRUCTION ,0, PROFF_INSTR ,0,5, "proff" };
Assembler::Label Assembler::k125 = { &k126, INSTRUCTION ,0, PRON_INSTR ,0,4, "pron" };
Assembler::Label Assembler::k124 = { &k125, INSTRUCTION ,0, HIDEMAC_INSTR ,0,7, "hidemac" };
Assembler::Label Assembler::k123 = { &k124, INSTRUCTION ,0, SHOWMAC_INSTR ,0,7, "showmac" };
Assembler::Label Assembler::k122 = { &k123, INSTRUCTION ,0, INCLUDE_INSTR ,0,7, "include" };
Assembler::Label Assembler::k121 = { &k122, INSTRUCTION ,0, EOR_INSTR ,0,3, "eor" };
Assembler::Label Assembler::k120 = { &k121, INSTRUCTION ,0, ENDIF_INSTR ,0,5, "endif" };
Assembler::Label Assembler::k119 = { &k120, INSTRUCTION ,0, IFMI_INSTR ,0,4, "ifmi" };
Assembler::Label Assembler::k118 = { &k119, INSTRUCTION ,0, IFPL_INSTR ,0,4, "ifpl" };
Assembler::Label Assembler::k117 = { &k118, INSTRUCTION ,0, IF_INSTR ,0,4, "ifne" };
Assembler::Label Assembler::k116 = { &k117, INSTRUCTION ,0, IFEQ_INSTR ,0,4, "ifeq" };
Assembler::Label Assembler::k115 = { &k116, INSTRUCTION ,0, IF_INSTR ,0,2, "if" };
Assembler::Label Assembler::k114 = { &k115, INSTRUCTION ,0, BEND_INSTR ,0,4, "bend" };
Assembler::Label Assembler::k113 = { &k114, INSTRUCTION ,0, BLOCK_INSTR ,0,5, "block" };
Assembler::Label Assembler::k112 = { &k113, INSTRUCTION ,0, ENDM_INSTR ,0,4, "endm" };
Assembler::Label Assembler::k111 = { &k112, INSTRUCTION ,0, MACRO_INSTR ,0,7, "segment" };
Assembler::Label Assembler::k110 = { &k111, INSTRUCTION ,0, MACRO_INSTR ,0,5, "macro" };
Assembler::Label Assembler::k109 = { &k110, INSTRUCTION ,0, LBL_INSTR ,0,3, "lbl" };
Assembler::Label Assembler::k108 = { &k109, INSTRUCTION ,0, GOTO_INSTR ,0,4, "goto" };
Assembler::Label Assembler::k107 = { &k108, INSTRUCTION ,0, VAR_INSTR ,0,3, "var" };
Assembler::Label Assembler::k106 = { &k107, INSTRUCTION ,0, BYTE_INSTR ,0,4, "byte" };
Assembler::Label Assembler::k105 = { &k106, INSTRUCTION ,0, RTA_INSTR ,0,3, "rta" };
Assembler::Label Assembler::k104 = { &k105, INSTRUCTION ,0, WORD_INSTR ,0,4, "word" };
Assembler::Label Assembler::k103 = { &k104, INSTRUCTION ,0, SHIFT_INSTR ,0,5, "shift" };
Assembler::Label Assembler::k102 = { &k103, INSTRUCTION ,0, NULL_INSTR ,0,4, "null" };
Assembler::Label Assembler::k101 = { &k102, INSTRUCTION ,0, TEXT_INSTR ,0,4, "text" };

Assembler::Label Assembler::k98 = { &k101, Y_REGISTER ,0, 0x0021 ,0,1, "y" };
Assembler::Label Assembler::InstructionLabelList = { &k98, X_REGISTER ,0, 0x0041 ,0,1, "x" };

Assembler::Label Assembler::EndTable = { 0,0,0,0,0,0,"" };
Assembler::Label Assembler::LabelList_2 = { &EndTable, A_REGISTER ,0, 0x0061 ,0,1, "a" };

Assembler::Label Assembler::k0 = { &LabelList_2, MNEMONIC ,0, 0x0001 ,0,3, "ora" };
Assembler::Label Assembler::k1 = { &k0, MNEMONIC ,0, 0x0021 ,0,3, "and" };
Assembler::Label Assembler::k2 = { &k1, MNEMONIC ,0, 0x0041 ,0,3, "eor" };
Assembler::Label Assembler::k3 = { &k2, MNEMONIC ,0, 0x0061 ,0,3, "adc" };
Assembler::Label Assembler::k4 = { &k3, MNEMONIC ,0, 0x0c81 ,0,3, "sta" };
Assembler::Label Assembler::k5 = { &k4, MNEMONIC ,0, 0x00a1 ,0,3, "lda" };
Assembler::Label Assembler::k6 = { &k5, MNEMONIC ,0, 0x00c1 ,0,3, "cmp" };
Assembler::Label Assembler::k7 = { &k6, MNEMONIC ,0, 0x00e1 ,0,3, "sbc" };
Assembler::Label Assembler::k8 = { &k7, MNEMONIC ,0, 0x0102 ,0,3, "asl" };
Assembler::Label Assembler::k9 = { &k8, MNEMONIC ,0, 0x0122 ,0,3, "rol" };

Assembler::Label Assembler::k10 = { &k9, MNEMONIC ,0, 0x0142 ,0,3, "lsr" };
Assembler::Label Assembler::k11 = { &k10, MNEMONIC ,0, 0x0162 ,0,3, "ror" };
Assembler::Label Assembler::k12 = { &k11, MNEMONIC ,0, 0x0dc2 ,0,3, "dec" };  //FALSCHE KATEGORIE!!!!!!!!
Assembler::Label Assembler::k13 = { &k12, MNEMONIC ,0, 0x0de2 ,0,3, "inc" };  //FALSCHE KATEGORIE!!!!!!!!
Assembler::Label Assembler::k14 = { &k13, MNEMONIC ,0, 0x0210 ,0,3, "bpl" };
Assembler::Label Assembler::k15 = { &k14, MNEMONIC ,0, 0x0230 ,0,3, "bmi" };
Assembler::Label Assembler::k16 = { &k15, MNEMONIC ,0, 0x0250 ,0,3, "bvc" };
Assembler::Label Assembler::k17 = { &k16, MNEMONIC ,0, 0x0270 ,0,3, "bvs" };
Assembler::Label Assembler::k18 = { &k17, MNEMONIC ,0, 0x0290 ,0,3, "bcc" };
Assembler::Label Assembler::k19 = { &k18, MNEMONIC ,0, 0x02b0 ,0,3, "bcs" };

Assembler::Label Assembler::k20 = { &k19, MNEMONIC ,0, 0x02d0 ,0,3, "bne" };
Assembler::Label Assembler::k21 = { &k20, MNEMONIC ,0, 0x02f0 ,0,3, "beq" };
Assembler::Label Assembler::k22 = { &k21, MNEMONIC ,0, 0x0320 ,0,3, "jsr" };
Assembler::Label Assembler::k23 = { &k22, MNEMONIC ,0, 0x0440 ,0,3, "jmp" };
Assembler::Label Assembler::k24 = { &k23, MNEMONIC ,0, 0x05a2 ,0,3, "ldx" };
Assembler::Label Assembler::k25 = { &k24, MNEMONIC ,0, 0x06a0 ,0,3, "ldy" };
Assembler::Label Assembler::k26 = { &k25, MNEMONIC ,0, 0x0782 ,0,3, "stx" };
Assembler::Label Assembler::k27 = { &k26, MNEMONIC ,0, 0x0880 ,0,3, "sty" };
Assembler::Label Assembler::k28 = { &k27, MNEMONIC ,0, 0x09e0 ,0,3, "cpx" };
Assembler::Label Assembler::k29 = { &k28, MNEMONIC ,0, 0x09c0 ,0,3, "cpy" };

Assembler::Label Assembler::k30 = { &k29, MNEMONIC ,0, 0x0a18 ,0,3, "clc" };
Assembler::Label Assembler::k31 = { &k30, MNEMONIC ,0, 0x0a38 ,0,3, "sec" };
Assembler::Label Assembler::k32 = { &k31, MNEMONIC ,0, 0x0a78 ,0,3, "sei" };
Assembler::Label Assembler::k33 = { &k32, MNEMONIC ,0, 0x0a58 ,0,3, "cli" };
Assembler::Label Assembler::k34 = { &k33, MNEMONIC ,0, 0x0af8 ,0,3, "sed" };
Assembler::Label Assembler::k35 = { &k34, MNEMONIC ,0, 0x0ad8 ,0,3, "cld" };
Assembler::Label Assembler::k36 = { &k35, MNEMONIC ,0, 0x0a88 ,0,3, "dey" };
Assembler::Label Assembler::k37 = { &k36, MNEMONIC ,0, 0x0a8a ,0,3, "txa" };
Assembler::Label Assembler::k38 = { &k37, MNEMONIC ,0, 0x0a98 ,0,3, "tya" };
Assembler::Label Assembler::k39 = { &k38, MNEMONIC ,0, 0x0a9a ,0,3, "txs" };

Assembler::Label Assembler::k40 = { &k39, MNEMONIC ,0, 0x0aea ,0,3, "nop" };
Assembler::Label Assembler::k41 = { &k40, MNEMONIC ,0, 0x0a00 ,0,3, "brk" };
Assembler::Label Assembler::k42 = { &k41, MNEMONIC ,0, 0x0a60 ,0,3, "rts" };
Assembler::Label Assembler::k43 = { &k42, MNEMONIC ,0, 0x0a40 ,0,3, "rti" };
Assembler::Label Assembler::k44 = { &k43, MNEMONIC ,0, 0x0a48 ,0,3, "pha" };
Assembler::Label Assembler::k45 = { &k44, MNEMONIC ,0, 0x0a68 ,0,3, "pla" };
Assembler::Label Assembler::k46 = { &k45, MNEMONIC ,0, 0x0a08 ,0,3, "php" };
Assembler::Label Assembler::k47 = { &k46, MNEMONIC ,0, 0x0a28 ,0,3, "plp" };
Assembler::Label Assembler::k48 = { &k47, MNEMONIC ,0, 0x0aa8 ,0,3, "tay" };
Assembler::Label Assembler::k49 = { &k48, MNEMONIC ,0, 0x0aaa ,0,3, "tax" };

Assembler::Label Assembler::k50 = { &k49, MNEMONIC ,0, 0x0ab8 ,0,3, "clv" };
Assembler::Label Assembler::k51 = { &k50, MNEMONIC ,0, 0x0aba ,0,3, "tsx" };
Assembler::Label Assembler::k52 = { &k51, MNEMONIC ,0, 0x0ac8 ,0,3, "iny" };
Assembler::Label Assembler::k53 = { &k52, MNEMONIC ,0, 0x0aca ,0,3, "dex" };
Assembler::Label Assembler::k54 = { &k53, MNEMONIC ,0, 0x0ae8 ,0,3, "inx" };
Assembler::Label Assembler::LabelList = { &k54, MNEMONIC ,0, 0x0b20 ,0,3, "bit" };


/*
	ADDRESSMODES:
		$10
		$1000
		$10,x
		$1000,x
		$10,y
		$1000,y
		#00
		($10,x)
		($10),y
		a(kkumulator)
		relative
		($1000)
		<nothing>
*/

Bool Assembler::AddressmodeOperandSize[] = {0,1,0,1,0,1,0,0,0,-1,0,1,-1};

CategoryType Assembler::CategoryTable[] =
{
			// ora
		0x4,0xc,0x14,0x1c,-1,0x18,0x8,0x0,0x10,-1,-1,-1,-1,
			// asl
		0x4,0xc,0x14,0x1c,-1,-1,-1,-1,-1,0x8,-1,-1,0x8,
			// beq
		-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,0x00,-1,-1,
			// jsr
		-1,0x0,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,
			// jmp
		-1,0xc,-1,-1,-1,-1,-1,-1,-1,-1,-1,0x2c,-1,
			// ldx
		0x4,0xc,-1,-1,0x14,0x1c,0x0,-1,-1,-1,-1,-1,-1,
			// ldy
		0x4,0xc,0x14,0x1c,-1,-1,0x0,-1,-1,-1,-1,-1,-1,
			// stx
		0x4,0xc,-1,-1,0x14,-1,-1,-1,-1,-1,-1,-1,-1,  //BLDSINN DIRECT!!!!!!!!!!!!
			// sty
		0x4,0xc,0x14,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,  // -- || --     !!!!!!!!!!!!
			// cpx
		0x4,0xc,-1,-1,-1,-1,0x0,-1,-1,-1,-1,-1,-1,
			// nop
		-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,0x00,
			// bit
		0x4,0xc,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,
			// sta
		0x4,0xc,0x14,0x1c,-1,0x18,-1,0x0,0x10,-1,-1,-1,-1,
			// dec
		0x4,0xc,0x14,0x1c,-1,-1,-1,-1,-1,-1,-1,-1,-1
};

Flags Assembler::Instr_AssembleStatus[] =
{
	//0
	AWAIT_TEXT, AWAIT_TEXT, AWAIT_TEXT, AWAIT_NUMBER, AWAIT_NUMBER,
	AWAIT_NUMBER, AWAIT_NUMBER, AWAIT_LBL_LABEL, AWAIT_ENDOFLINE,
	AWAIT_ENDOFLINE,
	//10
	AWAIT_ENDOFLINE, AWAIT_ENDOFLINE, AWAIT_ENDOFLINE, AWAIT_NUMBER,
	AWAIT_NUMBER, AWAIT_NUMBER, AWAIT_NUMBER, AWAIT_ENDOFLINE,
	AWAIT_NUMBER, AWAIT_NUMBER,
	//20
	AWAIT_NUMBER, AWAIT_TEXT, AWAIT_ENDOFLINE, AWAIT_ENDOFLINE,
	AWAIT_ENDOFLINE, AWAIT_ENDOFLINE, AWAIT_TEXT, AWAIT_NUMBER,
	AWAIT_NUMBER

};

Bool Assembler::Instr_OperandIsLong[] =
{
	//0
	FALSE, FALSE, FALSE, TRUE, TRUE, FALSE, TRUE, FALSE, FALSE, FALSE,
	//10
	FALSE, FALSE, FALSE, TRUE, TRUE, TRUE, TRUE, FALSE, TRUE, FALSE,
	//20
	FALSE, FALSE, FALSE, FALSE, FALSE, FALSE, FALSE, TRUE, TRUE
};

Bool Assembler::Instr_SeveralOperands[] =
{
	//0
	FALSE, FALSE, FALSE, TRUE, TRUE, TRUE, FALSE, FALSE, FALSE, FALSE,
	//10
	FALSE, FALSE, FALSE, FALSE, FALSE, FALSE, FALSE, FALSE, FALSE, FALSE,
	//20
	FALSE, FALSE, FALSE, FALSE, FALSE, FALSE, TRUE, FALSE, FALSE
};

Bool Assembler::Instr_Declaration[] =
{
	//0
	FALSE, FALSE, FALSE, FALSE, FALSE, FALSE, TRUE, FALSE, TRUE, FALSE,
	//10
	FALSE, FALSE, FALSE, FALSE, FALSE, FALSE, FALSE, FALSE, FALSE, FALSE,
	//20
	FALSE, FALSE, FALSE, FALSE, FALSE, FALSE, FALSE, FALSE, TRUE
};

Flags Assembler::Instr_DeclareAs[] =
{
	//0
	ORDINARY_LABEL, ORDINARY_LABEL, ORDINARY_LABEL, ORDINARY_LABEL,
	ORDINARY_LABEL, ORDINARY_LABEL, VARIABLE, FORBIDDEN, LBL_LABEL,
	MACRO_LABEL,
	//10
	IGNORE, ORDINARY_LABEL, ORDINARY_LABEL, ORDINARY_LABEL,
	ORDINARY_LABEL, ORDINARY_LABEL, ORDINARY_LABEL, ORDINARY_LABEL,
	ORDINARY_LABEL, ORDINARY_LABEL,
	//20
	ORDINARY_LABEL, ORDINARY_LABEL, ORDINARY_LABEL, ORDINARY_LABEL,
	ORDINARY_LABEL, ORDINARY_LABEL, ORDINARY_LABEL, ORDINARY_LABEL,
	CONSTANT
};


//*************************************************
//**                                             **
//**            SOURCE TEXT HANDLING             **
//**                                             **
//*************************************************

void Assembler::PrintLabels()
{
	Label* label = &LabelList_2;
	label = label->nextlist;

	while (label->nextlist)
	{
		term << "\nLABEL: " << label->name;
		term << "  value = " << label->value;
		term << "  block = " << label->block_number;
		term << "  level = " << block_level_list[label->block_number];
		term << "  defined = " << (short) label->defined;
		term << "  type = " << (short) label->type;

		label = label->nextlist;
	}
}

void Assembler::DeleteLabelTable()
{
	Label* tab = EndTable.nextlist;
	Label* tab2;

	while (tab)
	{
		tab2 = tab->nextlist;
		delete tab;
		tab = tab2;
	}
	LabelList_2.nextlist = &EndTable;
	EndTable.nextlist = NULL;
}
/*
Map* MacroMarker(Map& map)
{
	Map* macro_caller_map = map.macro_caller_map;
	
	if (! macro_caller_map)
		error = NO_MACRO_MARKER_ALLOWED;

	char x = map.base[map.position++];
	if ( x < '1' || x > '9');
		error = ILLEGAL_MACRO_MARKER;

	int marker_number = x - '1';
	if (marker_number >= macro_caller_map->number_of_macro_markers)
		error = MACRO_MARKER_NOT_DEFINED;

	if (map_list_counter >= MAP_LIST_SIZE)
	{
		error = TOO_HIGH_MACRO_AND_INCLUDE_DEPTH;
	}

	Map* new_map = &(map_list[++map_list_counter]);
	new_map->base = macro_caller_map->macro_marker_base[marker_number];
	new_map->position = 0;
	new_map->length = macro_caller_map->macro_marker_length[marker_number];
	new_map->macro_caller_map = macro_caller_map->macro_caller_map;

	return new_map;
}*/

bool Assembler::PopMap(Map* map)
{
	if (--map_list_counter < 0) return false;
			
	*map = map_list[map_list_counter];
	/*
	int c = sizeof(Map);
	char* base = (char*) &(map_list[map_list_counter]);
	char* map_addr = (char*) map;
	while (c-->0)
		map_addr[c] = base[c];
		*/
	return true;
}

bool Assembler::PushMap(Map* map)
{
	if (map_list_counter >= MAP_LIST_SIZE) return false;

	map_list[map_list_counter++] = *map;
	/*
	int c = sizeof(Map);
	char* base = (char*) &(map_list[map_list_counter++]);
	char* map_addr = (char*) map;
	while(c-->0)
		base[c] = map_addr[c];
		*/
	return true;
}

void Assembler::GetLabel(Map* map,Label*& label,BOOL enter_new_label)
{
	char*					mapbase			= map->base;
	Long					mapposition		= map->position;
	Long					maxlen			= map->length-mapposition;

	//	get labellength //

	char					x;
	int						labellength = 0;
	int						labellength_indeed;

	while (1)
	{
		if (labellength >= maxlen) break;

		x = mapbase[mapposition+labellength];
		if ( CHECK_ON_LETTER || CHECK_ON_DIGIT ) labellength++;
		else break;
	}

	labellength_indeed = labellength;
	if (labellength > MAX_LABEL_LENGTH)
	{
		labellength = MAX_LABEL_LENGTH;
		warning = LABEL_TOO_LONG;
	}

	//	search label in labellist //

	Label*	searchlabel = map->labellist; //!!!!!!!! &LabelList
	Label*	previous_searchlabel = 0;
	Label*	new_label;
	Bool		labelfound = FALSE;
	Bool		label_has_been_found = FALSE;

	unsigned short curr_block_lvl = block_level;
	unsigned short curr_block = current_block;
	unsigned short comparing_block,comparing_block_level;

	while (searchlabel->nextlist)
	{
		short c = searchlabel->namelength;
		if (c == labellength)
		{
			labelfound = TRUE;
			while (c-->0)
			{
				if (searchlabel->name[c] != mapbase[mapposition+c])
					{ labelfound = FALSE; 	break; }
			}

			if (labelfound)
			{
				label_has_been_found = TRUE;
				comparing_block = searchlabel->block_number;
				comparing_block_level = block_level_list[comparing_block];

				while (curr_block_lvl > comparing_block_level)
				{
					curr_block = mother_block_list[curr_block];
					curr_block_lvl--;
				}

				if (curr_block == comparing_block)
					break;
			}
		}

		if (label_has_been_found && !labelfound)
			break;

		labelfound = FALSE;
		previous_searchlabel = searchlabel;
		searchlabel = searchlabel->nextlist;
	}

	// enter new label //

	if (! labelfound && enter_new_label)
	{
		new_label = new Label;
		previous_searchlabel->nextlist = new_label;

		short c = labellength;
		new_label->name[c] = 0;
		while (c-->0) new_label->name[c] = mapbase[mapposition+c];

		new_label->namelength	= labellength;
		new_label->type			= ORDINARY_LABEL;
		new_label->defined		= FALSE;
		new_label->block_number	= 0;
		new_label->nextlist		= searchlabel;
		searchlabel = new_label;
	}

	label					= searchlabel;
	map->position      = mapposition+labellength_indeed;
}

bool Assembler::DefineLabel(Label*& definition_label)
{
	//term << "\n *** define label ***";
	//PrintLabels();

	Label* label = definition_label;
	Label* searchlabel;
	Label* previous_searchlabel = 0;

	if (label->defined)
	{
		if (block_level == block_level_list[label->block_number])
		{
			error = DOUBLE_DEFINITION;
			return false;
		}
		else
		{
			searchlabel = new Label;
			*searchlabel = *label;
			/*
			char* from = (char*) label;
			char* to = (char*) searchlabel;

			int c = sizeof(Label);
			while (c-->0)
				to[c] = from[c];
				*/
			label = searchlabel;
		}
	}
	else
	{
		if (block_level == 0)
		{
			label->defined = TRUE;
			label->type = ORDINARY_LABEL;
			definition_label = label;
			
	//term << "\n END DEFINE";
	//PrintLabels();
			return true;
		}

		searchlabel = &LabelList_2; ////map.labellist;

		while (searchlabel != 0)
		{
			if (searchlabel == label)
			{
				previous_searchlabel->nextlist = label->nextlist;
				break;
			}
			previous_searchlabel = searchlabel;
			searchlabel = searchlabel->nextlist;
		}
	}

	searchlabel = &LabelList_2; /////map.labellist;
	label->defined = TRUE;
	label->type = ORDINARY_LABEL;
	label->block_number = current_block;

	unsigned short comparing_block_level;
	Bool labelfound = FALSE;
	Bool label_has_been_found = FALSE;
	short namelength = label->namelength;
	char* labelname = label->name;
	
	while (searchlabel->nextlist)
	{
		short c = searchlabel->namelength;
		if (c == namelength)
		{
			labelfound = TRUE;
			while (c-->0)
			{
				if (searchlabel->name[c] != labelname[c])
					{ labelfound = FALSE; 	break; }
			}

			if (labelfound)
			{
				label_has_been_found = TRUE;
				comparing_block_level = block_level_list[searchlabel->block_number];

				if (block_level >= comparing_block_level)
					break;
			}
		}

		if (label_has_been_found && !labelfound)
			break;

		labelfound = FALSE;
		previous_searchlabel = searchlabel;
		searchlabel = searchlabel->nextlist;
	}

	previous_searchlabel->nextlist = label;
	label->nextlist = searchlabel;
	definition_label = label;


	//term << "\n END DEFINE";
	//PrintLabels();
	return true;
}




/*
void GetLabel(Map& map,Label*& label,BOOL enter_new_label)
{
	char*					mapbase			= map.base;
	Long					mapposition		= map.position;
	Long					maxlen			= map.length-mapposition;

	//	get labellength //

	char					x;
	short					labellength = 0;

	while (1)
	{
		if (labellength >= maxlen) break;

		x = mapbase[mapposition+labellength];
		if ( CHECK_ON_LETTER || CHECK_ON_DIGIT ) labellength++;
		else break;
	}

	//	search label in labellist //

	Label*	searchlabel = map.labellist;
	Bool		labelfound = FALSE;

	while (searchlabel->nextlist)
	{
		short c = searchlabel->namelength;
		if (c == labellength)
		{
			labelfound = TRUE;
			while (c-->0)
			{
				if (searchlabel->name[c] != mapbase[mapposition+c])
					{ labelfound = FALSE; 	break; }
			}
			if (labelfound) break;
		}
		searchlabel = searchlabel->nextlist;
	}

	// enter new label //

	if (! labelfound && enter_new_label)
	{
		short c = labellength;
		searchlabel->name[c] = 0;
		while (c-->0) searchlabel->name[c] = mapbase[mapposition+c];

		searchlabel->namelength = labellength;
		searchlabel->type			= ORDINARY_LABEL;
		searchlabel->defined		= FALSE;

		searchlabel->nextlist 	= new Label;
		searchlabel->nextlist->nextlist = 0;
	}

	label					= searchlabel;
	map.position      = mapposition+labellength;
}*/

Flags Assembler::GetDecimalNumber(Map* map,ValueType& number)
{
	char*					mapbase			= map->base;
	Long					mapposition		= map->position;
	Long					maxlen			= map->length-mapposition;

	//	get labellength //

	char					x;
	short					labellength = 0;
							number = 0;

	while (1)
	{
		if (labellength >= maxlen) break;

		x = mapbase[mapposition+labellength];
		if ( CHECK_ON_DIGIT)
		{
			number = number*10 + (ValueType) (x - '0');
			labellength++;
		}
		else break;
	}

	map->position      = mapposition+labellength;
	return OK;
}

Flags Assembler::GetHexNumber(Map* map,ValueType& number)
{
	char*					mapbase			= map->base;
	Long					mapposition		= map->position;
	Long					maxlen			= map->length-mapposition;

	//	get labellength //

	char					x;
	short					labellength = 0;
							number = 0;

	while (1)
	{
		if (labellength >= maxlen) break;

		x = mapbase[mapposition+labellength];
		if ( CHECK_ON_DIGIT ) x -= '0';
			else if ( x >= 'a' && x <= 'z' ) x -= 'a'-10;
				//else x = 20;
				else break;
		//if (x != 20)
		//{
		number = (number << 4) + (ValueType) x;
		labellength++;
		//}
		//else break;
	}

	map->position      = mapposition+labellength;
	return OK;
}

Flags Assembler::GetBinaryNumber(Map* map,ValueType& number)
{
	char*					mapbase			= map->base;
	Long					mapposition		= map->position;
	Long					maxlen			= map->length-mapposition;

	//	get labellength //

	char					x;
	short					labellength = 0;
							number = 0;

	while (1)
	{
		if (labellength >= maxlen) break;

		x = mapbase[mapposition+labellength];
		if ( x == '0' || x == '1')
		{
			number = (number<<1) + (ValueType) (x-'0');
			labellength++;
		}
		else break;
	}

	map->position      = mapposition+labellength;
	return OK;
}

Flags Assembler::GetString(Map* map,Long& stringlength)
{
	stringlength = 0;

	while (1)
	{
		//if (map.position+stringlength < map.length)
		//{
			char x = map->base[map->position+stringlength];

			if (x == QUOTATION_MARK)
			{
				map->position += stringlength+1;
				return OK;
			}

			if (! STRING_CHAR)
			{
				map->position += stringlength;
				return ILLEGAL_STRING;
			}
			stringlength++;
		//}
		//else
		//	return ILLEGAL_STRING;
	}
}

Flags Assembler::GetNextLine(Map* map)
{
//	if (map.position < 2) map.position -= 2;

	/*	if (map.base[map.position-2] == ENDOFLINE &&
		map.base[map.position-1] == ENDOFLINE_2)
			return OK;
*/
//	while (1)
//{

a1:
		if (map->position > map->length)
			if (!PopMap(map)) return END_OF_SOURCE_CODE;
			else
				goto a1;
	
		//if (map->position >= 2)
		//	if ( *((short*) (map->base+map->position-2)) == ENDOFLINE_SHORT)
		
		if (map->position >= 1)
			if ( *(map->base+map->position-1) == ENDOFLINE)
				return OK;

		map->position++;
		goto a1;
			

	/*	char x = map.base[map.position++];

		//if (x <= INVALID) return INVALID_SOURCE_FILE;
		if (x == ENDOFLINE)
		{
			if (map.base[map.position++] == ENDOFLINE_2)
				return OK;
			else
				//return INVALID_SOURCE_FILE;
				map.position--;
		}
	}*/
}

Flags Assembler::GetThisLine(Map* map)
{
	while (1)
	{
//		if (map->position < 2)
		if (map->position <= 0)
		{
			//map->position = 0;
			return OK;
		}

//		if (map->base[map->position-2] == ENDOFLINE && map->base[map->position-1] == ENDOFLINE_2)
		if (map->base[map->position-1] == ENDOFLINE)
			return OK;
		map->position--;
	}
}

char Assembler::Make_C64_ASCII(char ch)
{
	if (ch >= 'a' && ch <= 'z')
		ch ^= 0x20;
	else
		if (ch >= 'A' && ch <= 'Z')
			ch |=0x80;
	return ch;
}
/*
Flags GetInstruction(Map& map)
{
	if (i

IndexType GetInstruction(Map& map)
{
	while (1)
	{
		(map.position >= map.length) return END_OF_SOURCE_CODE;

		char z = map.base[map.position];

		if (z == QUOTATION_MARK || z == SEMIKOLON)
			return GetNextLine(map);
		
//		if (z == ENDOFLINE && map.base[map.position+1] == ENDOFLINE_2)
//			linenumber++;

		if (z == POINT)
		{
			map.position++;
			GetLabel(map,FALSE)
			if (! map.label->nextlist) return NO_INSTRUCTION;
			else
				GetNextLine(map);
			
			return OK;
		}

		map.position++;
/*
	/*	BOOL found = TRUE;
		int c = strlength;
		while (c-->0)
		{
			if (map.base[map.position+c] != searchstring[c])
			{
				found = FALSE;
				break;
			}
		}
		if (found) return OK;
		map.position++;*/
/*	}
}

			
*/


//*************************************************
//**                                             **
//**                ASSEMBLER                    **
//**                                             **
//*************************************************

Assembler::Map* Assembler::OpenSourceFile(char* filename)
{
		Map* map = new Map;
		char* buffer = 0;
		int file_length = 0;

		std::ifstream file(filename, std::ios::binary);
		
		if (! file.fail())
		{
			file.seekg(0,std::ios::end);
			file_length = file.tellg();
			file.seekg(0,std::ios::beg);

			buffer = new char[file_length+20];
			file.read(buffer,file_length);

			buffer[file_length++] = 13;		//add line-feed
			buffer[file_length++] = 10;

			file.close();
		}

		/*
		CFile file(filename,CFile::modeRead);
		int file_length = file.GetLength();
		char* buffer = new char[file_length+15];
		file.Read(buffer,file_length);
		file.Close();
		*/

		map->base = buffer;
		map->position = 0;
		map->length = file_length;
		map->labellist = &LabelList;
		map->macro_caller_map = 0;
		map->number_of_macro_markers = 0;
		//map.out = new char[0x10000];
		map->filename = filename;
		map->macro_call = false;
		map->start_linenumber = 0;
		return map;

/*	catch (CFileException*)
	{
		Map map;
		map.base = NULL;
		return map;
	}*/
}

Flags Assembler::AssembleMap(Map* map,BOOL first_pass)
{
	bool			hard_error = false;
	Map*			include_map;
	Map*			next_map;
	char*			filename;
	Long			linestart_position = map->position;
	//OutType*			out = new char[0x10000];
	Flags				preprocess_mode = ASSEMBLE;
	Flags 			assemblerlinetype;
	Flags				assemblestatus;
	Bool				bypassoperand;
	Bool				bypassoperand_permitted;
	Bool           labeldeclaration;
	Label*			declarationlabel = 0;
	unsigned short	outposition = 0x1000;
	unsigned short outposition_linestart;
	unsigned short start_outposition = outposition;
	unsigned short start_outposition_aid_variable;
	Label*			label = 0;
	IndexType		instruction;
	Flags				send = NO_SEND;
	Flags				send_2 = RESET;
						error = OK;
						warning = OK;
	Long				linenumber = map->start_linenumber;
	Long				string;
	Long				stringlength;
	Bool				severaloperands;
	Bool				operand_is_text;
	int				ifcounter = 0;
	int				secundary_ifcounter = 0;
	Bool				shiftlastchar;
	Bool				addnullbyte;
	ValueType		eor = 0;
	Long				ordinarylabeloffset = 0;
	Label*				macro_position = 0;
	bool				macro_definition = false;
	int				macro_counter = 0;
	int				include_counter = 0;
						map_list_counter = 0;
						block_counter = 0;
						current_block = 0;
						block_level = 0;
						block_level_list[0] = 0;

	Flags				operation;
	Flags				unitary_operation;
	Flags				turboass_lohibyte;
	ValueType		operandstack[OPERAND_STACK_SIZE];
	short				operandstackpoint;
	Flags				operationstack[OPERAND_STACK_SIZE];
	Flags				unitary_operationstack[OPERAND_STACK_SIZE];
	ValueType		leftoperand;
	ValueType		rightoperand;
	ValueType		operandoffset;
	Bool				operand_is_long;
	Bool				operand;

	Flags				addressmode;
	Bool				just_mnemonic_passed;
	Bool				addressmode_bracketopened;
	Bool				addressmode_bracketclosed;
	//Bool				operandsizeoptional;
	Bool				force_word_operand;

						while (1)
						{

	switch (send_2)
	{
		case RESET:
			//assemblerlinetype = UNDEFINED;
			//assemblestatus = NEWLINE;
			//bypassoperand = FALSE;
			//bypassoperand_permitted = FALSE;
			//labeldeclaration = FALSE;
			send = NO_SEND;
			//send_2
			error = OK;
			warning = OK;
			shiftlastchar = FALSE;
			addnullbyte = FALSE;

			operation = NO_OPERATION;
			unitary_operation = NO_OPERATION;
			turboass_lohibyte = 0;
			operandstackpoint = 0;
			operand = FALSE;
			//operandoffset = 0;

			addressmode = UNDEFINED;
			just_mnemonic_passed = FALSE;
			addressmode_bracketopened = FALSE;
			addressmode_bracketclosed = FALSE;
			//operandsizeoptional = FALSE;
			force_word_operand = FALSE;

		case NEWLINE_RESET:
			assemblerlinetype = UNDEFINED;
			assemblestatus = NEWLINE;
			bypassoperand = FALSE;
			bypassoperand_permitted = FALSE;
			labeldeclaration = FALSE;
			outposition_linestart = outposition;
			linestart_position = map->position;
			operandoffset = 0;
			send_2 = NO_SEND;
			if (!macro_counter) linenumber++;
		}

	while (1)
	{
		if (map->position < map->length) break;
		
		if (map->macro_call)
		{	if (!PopMap(map)) return OK; }
		else
		{
			//term << "\n alte map = " << map;
			map = map->macro_caller_map;
			if (! map) return OK;

				//		term << "\n   neue map = " << map;

			map->position = 0;
			linenumber = map->start_linenumber+1;
			//term << "\n   linenumber = " << linenumber; 
			//term << &(map->base[map->position]);
		}
	}


	char x = map->base[map->position];
	//term << x;

	if (preprocess_mode == ASSEMBLE)
	{
	/*
	if (getch() == 32 )
		{
				Label* la=map.labellist;
			while (la->nextlist)
			{
				printf( (char*)&la->name );
				printf("\n");
				getch();
				la = la->nextlist;
			}
			printf ("\n ENDOFLABELLIST\n");
		}
	  */
	/* *message << "\n\n LEFT = " << leftoperand << " RIGHT = "
		<< rightoperand << " instruction = " << (unsigned short)instruction
		<< "\assemblestatus = " << (short)assemblestatus;
*/
	  //	 short xx =(short) x;
		//*message << "\nZEICHEN = '" << x << "'";

	if (x == KLAMMERAFFE)
	{
		Map* macro_caller_map = map->macro_caller_map;
		map->position++;
	
		if (! macro_caller_map)
			error = NO_MACRO_MARKER_ALLOWED;
		else
		{
			char x = map->base[map->position];
			if ( x < '1' || x > '9')
				error = ILLEGAL_MACRO_MARKER;
			else
			{
				map->position++;
				int marker_number = x - '1';
				if (marker_number >= macro_caller_map->number_of_macro_markers)
					error = MACRO_MARKER_NOT_DEFINED;
				else
				{
					if (!PushMap(map)) return TOO_HIGH_MACRO_AND_INCLUDE_DEPTH;
					
					//map = &(map_list[++map_list_counter]);
					map->base = macro_caller_map->macro_marker_base[marker_number];
					map->position = macro_caller_map->macro_marker_position[marker_number];
					map->length = macro_caller_map->macro_marker_length[marker_number];
					map->macro_caller_map = macro_caller_map->macro_caller_map;
				}
			}
		}
	}
	else
		if (x == SEMIKOLON)
		{
			map->position++;
			if (GetNextLine(map) != OK) return OK;
			x = ENDOFLINE;
		}
		else
			if (x <= INVALID) x = INVALID;
			else
				if (x == ENDOFLINE)
				{
					map->position++;
					//if (map->base[map->position++] != ENDOFLINE_2) x = INVALID;
				//	else
						//*message << "\n*** endofline ***";
				//		x = ENDOFLINE;
				}
				else
					if (CHECK_ON_LETTER)
					{
						switch (assemblestatus)
						{
							case AWAIT_INSTRUCTION:
							case AWAIT_REGISTER:
							case AWAIT_X_REGISTER:
							case AWAIT_Y_REGISTER:
								map->labellist = &InstructionLabelList;
								GetLabel(map,label,FALSE);
								break;

							default:
								map->labellist = &LabelList;
								GetLabel(map,label,TRUE);
						}
						//label = map.label;
						x = LABEL;
					}
					else
						if (CHECK_ON_DIGIT)
						{
							GetDecimalNumber(map,rightoperand);
							//rightoperand = map.number;
							x = NUMBER;
						}
						else
							map->position++;

	switch (x)
	{
		case SPACE:
		case TABULATOR:
		case KLAMMERAFFE:
		case LINEFEED:
			break;

		case LABEL:
			switch (assemblestatus)
			{
				case NEWLINE:
					//*message << "--newline ";
					if (label->type == MNEMONIC)
					{
						/*if (ifcounter > 0)
						{
							send = IGNORE_SOURCECODE_LINE;
							break;
						}
						else
						{*/
							//*message << "--mnemonic";
							assemblerlinetype = CPUINSTRUCTION;
							instruction = label->index;
							just_mnemonic_passed = TRUE;
							assemblestatus = AWAIT_NUMBER;
							bypassoperand_permitted = first_pass;
						//}
					}
					else
						if (labeldeclaration) error = ILLEGAL_MNEMONIC;
						else
						{
							/*switch (label->type)
							{
								case INSTRUCTION:
								case X_REGISTER:
								case Y_REGISTER:
								case A_REGISTER:
								case MNEMONIC:
									error = LABEL_RESERVED;
							}*/
							if (label->type == A_REGISTER)
								error = LABEL_RESERVED;
							labeldeclaration = TRUE;
							declarationlabel = label;
						}
					break;

				case AWAIT_INSTRUCTION:
					if (label->type == INSTRUCTION)
					{
						instruction = label->index;
						bypassoperand_permitted = first_pass;
						/*if (ifcounter > 0)
							if (instruction == ENDIF_INSTR)
								ifcounter--;
							else
							{
								send = IGNORE_SOURCECODE_LINE;
								break;
							}*/
						switch (instruction)
						{
							case RTA_INSTR:
								operandoffset = -1;
								break;

							case NULL_INSTR:
								addnullbyte = TRUE;
								break;

							case SHIFT_INSTR:
								shiftlastchar = TRUE;
								break;

							case IF_INSTR:
							case IFEQ_INSTR:
							case IFPL_INSTR:
							case IFMI_INSTR:
								bypassoperand_permitted = FALSE;
								break;
						}
						assemblerlinetype = INSTRUCTION;
						assemblestatus = Instr_AssembleStatus[instruction];
						operand_is_long = Instr_OperandIsLong[instruction];
						severaloperands = Instr_SeveralOperands[instruction];
					}
					else error = ILLEGAL_PSEUDO_OPERATION;
					break;

				case AWAIT_NUMBER:
					if (just_mnemonic_passed)
					{
						addressmode = MEMORY;
						//operandsizeoptional = TRUE;
						just_mnemonic_passed = FALSE;
						
						if (label->type == A_REGISTER)
						{
							addressmode = ACCUMULATOR;
							assemblestatus = AWAIT_ENDOFLINE;
							break;
						}
					}
					if (label->defined)
					{
						rightoperand = label->value;
					//	if (label->type == ORDINARY_LABEL)
					//		rightoperand += ordinarylabeloffset; //DAS IST BLDSINN!: DER OFFSET MUSS BEI DER DEFINITION ADDIERT WERDEN!!!!!
						send = WORK_NUMBER;
					}
					else
					{
						if (bypassoperand_permitted)
						{
							bypassoperand = TRUE;
							send = WORK_NUMBER;
						}
						else
							error = UNDEFINED_STATEMENT;
					}
					break;

				case AWAIT_REGISTER:
					assemblestatus = AWAIT_ENDOFLINE;
					switch (label->type)
					{
						case X_REGISTER:
							addressmode = MEMORY_X_REGISTER;
							break;

						case Y_REGISTER:
							addressmode = MEMORY_Y_REGISTER;
							break;

						default:
							//term << "\n " <<(int)label->type << label->name;
							error = REGISTER_EXPECTED;
					}
					break;

				case AWAIT_X_REGISTER:
					assemblestatus = AWAIT_CLOSE_BRACKET;
					if (label->type != X_REGISTER)
						error = ILLEGAL_ADDRESSMODE;
					break;

				case AWAIT_Y_REGISTER:
					assemblestatus = AWAIT_ENDOFLINE;
					if (label->type != Y_REGISTER)
						error = ILLEGAL_ADDRESSMODE;
					break;

				case AWAIT_LBL_LABEL:
					assemblestatus = AWAIT_ENDOFLINE;
					if (label->defined == TRUE)
					{
						if (label->type != LBL_LABEL)
							error = ASSEMBLER_LABEL_EXPECTED;
					}
					else error = UNDEFINED_STATEMENT;
					break;

				case AWAIT_MACRO_LABEL:
					//term << "\n READ macro label";
					if (label->type != MACRO_LABEL)
						error = MACRO_NOT_DEFINED;
					macro_position = label; //  label->value;
					assemblestatus = AWAIT_TEXT;
					severaloperands = TRUE;
					break;

				default:
					error = SYNTAX;
			}
			break;

		case NUMBER:
			//*message << "  number  ";
			if (just_mnemonic_passed)
			{
				addressmode = MEMORY;
				//operandsizeoptional = TRUE;
				just_mnemonic_passed = FALSE;
			}
			if (assemblestatus == AWAIT_NUMBER) send = WORK_NUMBER;
			else error = NO_NUMBER_EXPECTED;
			break;

		case POINT:
			if (assemblerlinetype == UNDEFINED)
			{
				assemblerlinetype = INSTRUCTION;
				assemblestatus = AWAIT_INSTRUCTION;
			}
			else
				if (assemblestatus == AWAIT_CHAR)
				{
					operation = x;
					assemblestatus = AWAIT_NUMBER;
				}
					else
						error = SYNTAX;
			break;

		case ENDOFLINE:
			//*message << "\n PASS ENDOFLINE ";

			send_2 = RESET;

			if (operandstackpoint != 0)
			{
				error = BRACKET_ERROR;
				break;
			}

			if (operation != NO_OPERATION || unitary_operation != NO_OPERATION)
			{
				error = MISSING_OPERAND;
				break;
			}

/*			if (error != OK)
			{
				term << "\n ERROR in line " << linenumber << " : " << ErrorTable[error];

				error = OK;
				break;
			}
*/
			switch (assemblerlinetype)
			{
				case CPUINSTRUCTION:
					if (labeldeclaration)
					{
						/*if (declarationlabel->defined && first_pass)
						{
							error = DOUBLE_DEFINITION;
							break;
						}	*/
						//declarationlabel->defined = TRUE;
						if (first_pass)
							if (!DefineLabel(declarationlabel)) break;

						declarationlabel->value = (outposition) & 0xffff;
						
					}
					//*message << " CPU ";
					if (addressmode_bracketopened != addressmode_bracketclosed)
						error = BRACKET_ERROR;
					else
						if (addressmode == UNDEFINED)
							if (just_mnemonic_passed)
								addressmode = NOTHING;
							else
								if (addressmode_bracketopened)
									addressmode = BRACKET_MEMORY;

					if (addressmode == UNDEFINED)
						error = ILLEGAL_ADDRESSMODE;
					else
					{
						IndexType opcode = instruction;
						IndexType category = (opcode >> 8)*NUMBER_ADDRESSMODES;
						opcode &= 0xff;

						if (CategoryTable[category+RELATIVE] >= 0)
						{
							if (addressmode == MEMORY)
							{
								addressmode = RELATIVE;
								leftoperand -= outposition + 2;
								if (!bypassoperand)
									if (leftoperand < -128 || leftoperand > 127)
										error = BRANCH_OUT_OF_RANGE;
							}
							else error = UNALLOWED_ADDRESSMODE;
						}
						else
							/*if (operandsizeoptional && !bypassoperand)
								if (leftoperand >= 0 && leftoperand < 0x100)
								{
									if (CategoryTable[category + addressmode-1] >= 0)
										if (!first_pass && out[outposition] == 0)
											warning = OPERAND_SIZE_WORD_TAKEN;
										else
											addressmode--;
								}*/
							if (addressmode <= MEMORY_Y_REGISTER && CategoryTable[category + addressmode-1] >= 0)
								if (first_pass && !force_word_operand)
								{
							
									if (! bypassoperand)
									{
										if ((leftoperand >= 0 && leftoperand < 0x100) || turboass_lohibyte)
											addressmode--;
									}
									else
										if (turboass_lohibyte)
											addressmode--;
								}
								else
								{
									char opc = out[outposition];
									//term << "\n opc = " << (unsigned int) opc << "\n addressmode = " << addressmode;
									char opsizelow = ((leftoperand >= 0 && leftoperand < 0x100) || turboass_lohibyte);
									if (opc == addressmode)
									{	if (opsizelow && !force_word_operand)
											warning = OPERAND_SIZE_WORD_TAKEN;
									}
									else
										if (opc == addressmode-1)
										{	
											addressmode--;
											if (! opsizelow)
												error = PHASE_ERROR;
										}
										else
											error = ILLEGAL_PHASE_FLAG;
								}

						CategoryType c = CategoryTable[category + addressmode];
						if (c >= 0)
						{
							if (first_pass)
								out[outposition++] = addressmode;
							else
								out[outposition++] = (char) (opcode + c);
								//outposition++;

							operand_is_long = AddressmodeOperandSize[addressmode];
							if (operand_is_long >= 0)
								send = STORE_OPERAND;

							/*addressmode = UNDEFINED;
							just_mnemonic_passed = FALSE;
							addressmode_bracketopened = FALSE;
							addressmode_bracketclosed = FALSE;
							operandsizeoptional = FALSE;*/  // SCHON BEI LINE_RESET
						}
						else error = UNALLOWED_ADDRESSMODE;
					}
					break;

				case INSTRUCTION:
				  //*message << "\n   INSTRUCTION ! opern_is_text = "
				//	<< (short)operand_is_text;
					if (assemblestatus == AWAIT_NUMBER)
							{ error = NUMBER_MISSING; break; }
					else
					if (assemblestatus == AWAIT_ENDOFLINE ||
						assemblestatus == AWAIT_COMMA ||
						assemblestatus == AWAIT_CHAR ||
						instruction == MACROCALL_INSTR)
					{
						//term << declarationlabel->name;
						if (labeldeclaration && Instr_DeclareAs[instruction] != IGNORE)
						{
							/*if (instruction != VAR_INSTR) !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
								if (declarationlabel->defined && first_pass)
									error = DOUBLE_DEFINITION;
							declarationlabel->defined = TRUE;*/

							if (instruction != VAR_INSTR)
							{
								if (first_pass)
									if (!DefineLabel(declarationlabel)) break;
							}
							else
						//	{	term << "\n VAR INSTR in line " << linenumber;
						//		PrintLabels();
								if (declarationlabel->type == VARIABLE || !(declarationlabel->defined))
									declarationlabel->defined = TRUE;
								else
									error = DOUBLE_DEFINITION;
						//	}
							declarationlabel->type = Instr_DeclareAs[instruction];

							//term << "DECLARE_AS " << (short)Instr_DeclareAs[instruction];
							switch (Instr_DeclareAs[instruction])
							{
								case FORBIDDEN:
									warning = TURBOASS_NO_LABEL;
									break;

								case ORDINARY_LABEL:
									declarationlabel->value = (outposition_linestart) & 0xffff;
									break;

								case CONSTANT:
								case VARIABLE:
									switch (turboass_lohibyte)
									{
										case TURBOASS_LOBYTE_CHAR:
										leftoperand &= 0xff; break;
										case TURBOASS_HIBYTE_CHAR:
										leftoperand = (leftoperand >> 8) & 0xff; break;
									}
									turboass_lohibyte = 0;

									declarationlabel->value = leftoperand;
									send = CHECK_OPERAND;
									break;

								case LBL_LABEL:
								case MACRO_LABEL:
									declarationlabel->value = map->position;
									declarationlabel->map = map;
									declarationlabel->linenumber = linenumber;
									break;
							}
						}
						else
							if (Instr_Declaration[instruction])
							{
								error = LABEL_MISSING;
								break;
							}

						switch (instruction)
						{
							leftoperand += operandoffset;
							operandoffset = 0;
							switch (turboass_lohibyte)
							{
								case TURBOASS_LOBYTE_CHAR:
									leftoperand &= 0xff; break;
								case TURBOASS_HIBYTE_CHAR:
									leftoperand = (leftoperand >> 8) & 0xff; break;
							}
							turboass_lohibyte = 0;

							case RTA_INSTR:
								//*message << "__RTA_INSTR__";
							case BYTE_INSTR:
								//*message << "__BYTE_INSTR__";
							case WORD_INSTR:
								//*message << "__WORD_INSTR__";
								//send = STORE_OPERAND;
								//break;

							case NULL_INSTR:
								//addnullbyte = TRUE;
								//send = STORE_OPERAND;
								//break;

							case SHIFT_INSTR:
								//shiftlastchar = TRUE;
							case TEXT_INSTR:
								send = STORE_OPERAND;
								break;

							case IF_INSTR:
								secundary_ifcounter++;
								if (! leftoperand) send = SKIP_IF_BLOCK;//ifcounter++;
								break;

							case IFEQ_INSTR:
								secundary_ifcounter++;
								if (leftoperand) send = SKIP_IF_BLOCK;//ifcounter++;
								break;

							case IFMI_INSTR:
								secundary_ifcounter++;
								if (leftoperand >= 0) send = SKIP_IF_BLOCK;//ifcounter++;
								break;

							case IFPL_INSTR:
								secundary_ifcounter++;
								if (leftoperand < 0) send = SKIP_IF_BLOCK;//ifcounter++;
								//*message << "  " << ifcounter;
								break;

							case ENDIF_INSTR:
								if (ifcounter > 0)
									ifcounter--;

								if (secundary_ifcounter > 0)
									secundary_ifcounter--;
								else
									warning = ENDIF_WITHOUT_IF;
								break;

							case GOTO_INSTR:
								leftoperand = label->value;
								map->position = leftoperand;
								send = CHECK_OPERAND;
								if (!macro_counter) linenumber = label->linenumber;
								break;

							case LBL_INSTR:
							case VAR_INSTR:
							case DECLARATION_INSTR:
								break;

							case OFFS_INSTR:
								ordinarylabeloffset = leftoperand;
								send = CHECK_OPERAND;
								break;

							case EOR_INSTR:
								eor = leftoperand;
								send = CHECK_OPERAND;
								break;

							case SETDESTINATION_INSTR:
								if (start_outposition != outposition && !first_pass)
								{
									if (start_outposition > outposition)
									{
										outposition = 0xffff;
										warning = CODE_SUCEEDS_0XFFFF;
									}
									//try
									//{
										str filename_str = path;
										//char* filename;
										if (d_t_s__add_start_end_addresses_to_object_filename)
										{
											filename = (filename_str+"0000.prg").ch();
											char* hex_pointer = filename+strlen(filename)-8;
											std::sprintf(hex_pointer,"%.4x.prg",start_outposition);
											//wsprintf(hex_pointer+4,".prg",start_outposition);
										}
										else
											filename = (filename_str+".prg").ch();							
										char filearea[12];
										std::sprintf(filearea,"$%.4x-$%.4x",start_outposition,outposition);
										term << "\n writing  " << filearea << "  " << filename;

										std::ofstream file(filename,std::ofstream::binary);
										//CFile file(filename,CFile::modeCreate|CFile::modeWrite);		
										start_outposition_aid_variable = start_outposition + (unsigned short) ordinarylabeloffset;
										file.write((char *)(&start_outposition_aid_variable),2);
										file.write(out+start_outposition,outposition-start_outposition);
										file.close();
									//}
									//catch (CFileException*)
									//{ error = FILE_WRITE_ERROR; }
								}

								outposition = (unsigned short) leftoperand;
								start_outposition = outposition;
								send = CHECK_OPERAND;
								break;

							case END_INSTR:
								send = BREAK_ASSEMBLING;
								break;

							case MACRO_INSTR:
								preprocess_mode = AWAIT_ENDMACRO;
								macro_definition = true;
								break;

							case ENDM_INSTR:
								//term << "\n EndMacro " << macro_definition << "  " << macro_counter;
								if (macro_definition) macro_definition = false;
								else
									if (macro_counter == 0) warning = ENDMACRO_WITHOUT_MACRO;
									else
									{
										macro_counter--;
										if (!PopMap(map)) return PROGRAM;
									}
								break;

							case MACROCALL_INSTR:
								if (!PushMap(map)) return TOO_HIGH_MACRO_AND_INCLUDE_DEPTH;
								
								macro_counter++;
								map->macro_caller_map = &(map_list[map_list_counter-1]);
								map->position = macro_position->value;
								map->base = macro_position->map->base; 
								map->length = macro_position->map->length;
								map->macro_call = true;
								break;

							case INCLUDE_INSTR:
								//break;
								//std::cout << "StringLen " << stringlength;
								//std::cout << "String " << &(map.base[string]);
								
								filename = &(map->base[string]);
								filename[stringlength] = 0;

								//std::cout << filename;

								include_map = OpenSourceFile(filename);
								if (! include_map->base)
								{
									error = CANNOT_OPEN_FILE;
									hard_error = true;
									break;
								}
							
								//previous_map = new Map;
								next_map = new Map;
								*next_map = *map;
								
								//include_map = new Map;
								
								//*previous_map = *map;
								
								next_map->base = &(map->base[map->position]);
								next_map->length = map->length - map->position;
								next_map->start_linenumber = linenumber;
								map->length = linestart_position;
								
								/*
								map->base = include_map->base;
								map->position = include_map->position;
								map->length = include_map->length;
								map->filename = include_map->filename;
								*/

								map->macro_caller_map = include_map;
								include_map->macro_caller_map = next_map;
								//next_map->macro_caller_map = map->macro_caller_map;
								//map->macro_caller_map = next_map;

								map = include_map;
								linenumber = map->start_linenumber;

								/*
								std::cout << "\n" << previous_map->base;
								std::cout << "\n" << next_map->base;
								std::cout << "\n" << include_map->base;
								std::cout << "\n" << map->base;
								
								std::cout << "\n" << previous_map->length;
								std::cout << "\n" << next_map->length;
								std::cout << "\n" << include_map->length;
								std::cout << "\n" << map->length;

								std::cout << "\n" << previous_map->macro_caller_map;
								std::cout << "\n" << next_map->macro_caller_map;
								std::cout << "\n" << include_map->macro_caller_map;
								std::cout << "\n" << map->macro_caller_map;
								
								std::cout << "\n" << map->position;
								*/
								//return 0;
								//map->macro_call = false;

								//if (include_counter == 0) 
									//*start_map = *previous_map;

								include_counter++;
								break;

							case BLOCK_INSTR:
								block_counter++;
								if (block_counter == 0)
									error = TOO_MANY_BLOCKS;
								else
								{
									mother_block_list[block_counter] = current_block;
									block_level_list[block_counter] = ++block_level;
									current_block = block_counter;	
								}
								break;

							case BEND_INSTR:
								if (block_level == 0)
									warning = BEND_WITHOUT_BLOCK;
								else
								{
									block_level--;
									current_block = mother_block_list[current_block];
								}
								break;

							default:
								warning = NOT_IMPLEMENTED;
						}
					}
					else
						error = UNEXPECTED_LINEEND;
					break;

				case UNDEFINED:
					if (labeldeclaration)
					{
						/*if (declarationlabel->defined && first_pass)
							error = DOUBLE_DEFINITION;
						else
						{
							declarationlabel->value = (outposition + ordinarylabeloffset) & 0xffff;
							declarationlabel->defined = TRUE;
						}*/
						if (first_pass)
							if (!DefineLabel(declarationlabel)) break;
						declarationlabel->value = (outposition) & 0xffff;
					}
					break;
			}
			break;

		case CROSS:
			//term << "\n CROSS in line " << linenumber;
			if (assemblerlinetype == CPUINSTRUCTION && just_mnemonic_passed)
			{
				addressmode = DIRECT;
				just_mnemonic_passed = FALSE;
				break;
			}
			
			if (assemblerlinetype == UNDEFINED)
			{
				//term << "\n MACRO CALL";
				assemblerlinetype = INSTRUCTION;
				instruction = MACROCALL_INSTR;
				map->number_of_macro_markers = 0;
				assemblestatus = AWAIT_MACRO_LABEL;
				break;
			}

			error = SYNTAX;
			break;

		case COMMA:
			if (assemblestatus == AWAIT_CHAR ||
				assemblestatus == AWAIT_COMMA)
				switch (assemblerlinetype)
				{
					case CPUINSTRUCTION:
						if (addressmode_bracketopened)
							if (addressmode_bracketclosed)
							{
								assemblestatus = AWAIT_Y_REGISTER;
								addressmode = BRACKET_ZEROPAGE_Y;
							}
							else
							{
								assemblestatus = AWAIT_X_REGISTER;
								addressmode = BRACKET_ZEROPAGE_X;
							}
						else
							if (addressmode == MEMORY)
								assemblestatus = AWAIT_REGISTER;
							else
								error = ILLEGAL_ADDRESSMODE;
						break;

					case INSTRUCTION:
						if (severaloperands == TRUE)
						{
							if (instruction != MACROCALL_INSTR) send = STORE_OPERAND;
							if (operand_is_text) assemblestatus = AWAIT_TEXT;
							else assemblestatus = AWAIT_NUMBER;
						}
						else error = TOO_MANY_OPERANDS;
						break;

					default:
						error = SYNTAX;
				}
			else error = SYNTAX;
			break;

		case STRING:
		case PERCENT:
			if (just_mnemonic_passed)
			{
				addressmode = MEMORY;
				//operandsizeoptional = TRUE;
				just_mnemonic_passed = FALSE;
			}
			if (assemblestatus == AWAIT_NUMBER)
			{
				if (x == STRING)
					GetHexNumber(map,rightoperand);
				else
					GetBinaryNumber(map,rightoperand);
				//rightoperand = map.number;
				send = WORK_NUMBER;
			}
			else error = NO_NUMBER_EXPECTED;
			break;

		case PLUS:
		case MINUS:
		case SLASH:
		case AND:
		case COLON:
			if (assemblestatus == AWAIT_CHAR)
			{
				operation = x;
				assemblestatus = AWAIT_NUMBER;
			}
			else error = SYNTAX;
			break;

		/*case MINUS:
			if (assemblestatus == AWAIT_CHAR)
			{
				operation = MINUS;
				assemblestatus = AWAIT_NUMBER;
			}
			else error = SYNTAX;
			break;

		case SLASH:
			if (assemblestatus == AWAIT_CHAR)
			{
				operation = SLASH;
				assemblestatus = AWAIT_NUMBER;
			}
			else error = SYNTAX;
			break;*/

		case STAR:
			if (assemblestatus == AWAIT_CHAR)
			{
				operation = STAR;
				assemblestatus = AWAIT_NUMBER;
			}
			else
				if (assemblestatus == AWAIT_NUMBER)
				{
					if (just_mnemonic_passed)
					{
						addressmode = MEMORY;
						just_mnemonic_passed = FALSE;
					}
					rightoperand = outposition_linestart;
					send = WORK_NUMBER;
				}
				else
					if (assemblestatus == NEWLINE)
						assemblestatus = AWAIT_EQUAL;
					else error = SYNTAX;
			break;

		case OPEN_BRACKET:
			if (just_mnemonic_passed)
			 {	addressmode_bracketopened = TRUE;
				just_mnemonic_passed = FALSE;
				//*message << "\n OPENBRACKET";
				}
			else
				if (assemblestatus == AWAIT_NUMBER)
				{
					if (operandstackpoint < OPERAND_STACK_SIZE) 
					{
						operandstack[operandstackpoint] = leftoperand;
						operationstack[operandstackpoint] = operation;
						unitary_operationstack[operandstackpoint++] = unitary_operation;
						operation = NO_OPERATION;
						unitary_operation = NO_OPERATION;
					}
					else
						error = TOO_MANY_BRACKETS_OPENED;
				}
				else
					error = SYNTAX;
			break;

		case CLOSE_BRACKET:
			if (assemblestatus == AWAIT_CHAR)
			{
				if (operandstackpoint <= 0)
				{	//*message << "\n  CLOSEBRACKET";
					if (addressmode_bracketopened && !addressmode_bracketclosed)
					{
						addressmode_bracketclosed = TRUE;
						assemblestatus = AWAIT_COMMA;
					}
					else
						error = BRACKET_ERROR;
				}
				else
				{
					rightoperand = leftoperand;
					leftoperand = operandstack[--operandstackpoint];
					operation = operationstack[operandstackpoint];
					unitary_operation = unitary_operationstack[operandstackpoint];
					send = WORK_NUMBER;
				}
			}
			else
				if (assemblestatus == AWAIT_CLOSE_BRACKET)
				{
					assemblestatus = AWAIT_ENDOFLINE;
					addressmode_bracketclosed = TRUE;
				}
				else
					error = SYNTAX;
			break;

		case EQUAL:
			if (assemblestatus == NEWLINE)
				if (labeldeclaration)
				{
					instruction = DECLARATION_INSTR;
					bypassoperand_permitted = TRUE;
				}
				else
					error = LABEL_MISSING;
			else
				if (assemblestatus == AWAIT_EQUAL)
				{
					instruction = SETDESTINATION_INSTR;
					bypassoperand_permitted = FALSE;
				}
				else
					error = SYNTAX;

			assemblerlinetype = INSTRUCTION;
			assemblestatus = AWAIT_NUMBER;
			//bypassoperand_permitted = FALSE;
			break;

		case QUOTATION_MARK:
			switch (assemblestatus)
			{
				case AWAIT_TEXT:
					error = GetString(map,stringlength);
					///send = STORE_OPERAND;
					assemblestatus = AWAIT_COMMA;
					operand_is_text = TRUE;
					operand = TRUE;
					string = map->position - stringlength - 1;
				
					//*message << "\n  AWAIT_TEXT";
					if (assemblerlinetype == INSTRUCTION && instruction == MACROCALL_INSTR)
					{
						if (map->number_of_macro_markers >= 9)
							error = TOO_MANY_MACRO_PARAMETERS;
						else
						{
							map->macro_marker_base[map->number_of_macro_markers] = map->base;
							map->macro_marker_position[map->number_of_macro_markers] = map->position - stringlength - 1;
							map->macro_marker_length[map->number_of_macro_markers++] = map->position-1;
						}
					}
					break;

				case AWAIT_NUMBER:
					if (just_mnemonic_passed)
					{	
						addressmode = MEMORY;
						//operandsizeoptional = TRUE;
						just_mnemonic_passed = FALSE;
					}

					error = GetString(map,stringlength);
					if (error != OK) break;

					if (stringlength != 1)
						error = SYNTAX;
					else
					{
						rightoperand = (unsigned char) Make_C64_ASCII(map->base[map->position-2]);
						send = WORK_NUMBER;
					}
					break;

				default:
					error = SYNTAX;
			}
			break;

		case LOWER_CHAR:
		case HIGHER_CHAR:
			if (just_mnemonic_passed)
			{
				addressmode = MEMORY;
				//operandsizeoptional = TRUE;
				just_mnemonic_passed = FALSE;
			}
			if (assemblestatus == AWAIT_NUMBER && unitary_operation == NO_OPERATION)
				unitary_operation = x;
			else
				error = SYNTAX;
			break;

		case TURBOASS_LOBYTE_CHAR:
		case TURBOASS_HIBYTE_CHAR:
			if (just_mnemonic_passed)
			{
				addressmode = MEMORY;
				//operandsizeoptional = TRUE;
				just_mnemonic_passed = FALSE;
			}
			if (assemblestatus == AWAIT_NUMBER && turboass_lohibyte == 0)
				turboass_lohibyte = x;
			else
				error = SYNTAX;
			break;

		case EXCLAMATION_MARK:
			if (just_mnemonic_passed)
			{
				addressmode = MEMORY;
				just_mnemonic_passed = FALSE;
				force_word_operand = TRUE;
			}
			else
				error = SYNTAX;
			break;

		default:
			error = INVALID_SOURCE_FILE;
	}

	}// end of ''if (preprocess_mode == ASSEMBLE)''
	else 
	{
		map->position++;
		if (x == SPACE || x == TABULATOR || x == LINEFEED) {}
		else
			if (x == POINT)
			{
				if (assemblestatus == NEWLINE)
					assemblestatus = AWAIT_INSTRUCTION;
				else
					send = IGNORE_SOURCECODE_LINE;
			}
			else
				if (CHECK_ON_LETTER && assemblestatus == AWAIT_INSTRUCTION)
				{
					map->position--;
					map->labellist = &InstructionLabelList;
					GetLabel(map,label,FALSE);
					//label = map.label;

					if (label->nextlist && label->type == INSTRUCTION)
					{
						if (preprocess_mode == AWAIT_ENDMACRO && label->index == ENDM_INSTR)
							send = SWITCH_TO_ASSEMBLE_MODE;
						else
							if (preprocess_mode == AWAIT_ENDIF)
							{
								IndexType instr = label->index;
								if (instr == ENDIF_INSTR)
									if (ifcounter > 1) ifcounter--;
									else
										send = SWITCH_TO_ASSEMBLE_MODE;
								else
									if (instr == IF_INSTR || instr == IFEQ_INSTR || instr == IFMI_INSTR || instr == IFPL_INSTR)
									{
										ifcounter++;
										send = IGNORE_SOURCECODE_LINE;
									}
							}
							else
								send = IGNORE_SOURCECODE_LINE;
					}
					else
						send = IGNORE_SOURCECODE_LINE;
				}
				else
					send = IGNORE_SOURCECODE_LINE;
	
	}

	if (error != OK)
	{
		if (send == STORE_OPERAND && !operand_is_text)
		{
			outposition++;
			if (operand_is_long) outposition++;
		}
		//assemblestatus = AWAIT_ENDOFLINE;
		send = NO_SEND;
		/**message << "\n\n\n";
		message->close();
		return error;*/
	}

	switch (send)
	{
		case NO_SEND:
			break;

		case WORK_NUMBER:
			switch (unitary_operation)
			{
				case LOWER_CHAR:
					rightoperand &= 0xff; break;
				case HIGHER_CHAR:
					rightoperand = (rightoperand >> 8) & 0xff; break;
			}
			switch (operation)
			{
				case NO_OPERATION:
					leftoperand = rightoperand; break;
				case PLUS:
					leftoperand += rightoperand; break;
				case MINUS:
					leftoperand -= rightoperand; break;
				case STAR:
					leftoperand *= rightoperand; break;
				case SLASH:
					leftoperand /= rightoperand; break;
				case AND:
					leftoperand &= rightoperand; break;
				case POINT:
					leftoperand |= rightoperand; break;
				case COLON:
					leftoperand ^= rightoperand; break;
				default:
					error = PROGRAM;
			}
			operand = TRUE;
			operand_is_text = FALSE;
			assemblestatus = AWAIT_CHAR;
			operation = NO_OPERATION;
			unitary_operation = NO_OPERATION;
			break;

		case STORE_OPERAND:
			if (! operand)
			{
				if (!operand_is_text)
				{
					outposition++;
					if (operand_is_long) outposition++;
				}
				error = MISSING_OPERAND;
				
				turboass_lohibyte = 0;
				break;
			}
			else
			{
				if (operand_is_text)
				{
					Long d = stringlength;
					while (d-->0) 
						out[outposition++] = Make_C64_ASCII(map->base[string++]);						
					if (shiftlastchar)
						out[outposition-1] ^= 0x20;
					if (addnullbyte)
						out[outposition++] = 0;
					//shiftlastchar = 0;
					//addnullbyte = 0;
					//*message << "___STORE_TEXT___";
					if (turboass_lohibyte)
						error = SYNTAX;
				}
				else
				{
					//term << "\n bypass= " << short(bypassoperand);
					if (bypassoperand)
					{
					//	term << "\nbypasse";
						if (operand_is_long) outposition += 2;
						else outposition++;

						turboass_lohibyte = 0;
					}
					else
					{
						leftoperand += operandoffset;

						switch (turboass_lohibyte)
						{
							case TURBOASS_LOBYTE_CHAR:
								leftoperand &= 0xff; break;
							case TURBOASS_HIBYTE_CHAR:
								leftoperand = (leftoperand >> 8) & 0xff; break;
						}
						turboass_lohibyte = 0;

						out[outposition++] =
							(char) ((leftoperand ^ eor)& 0xff) ;
						if (operand_is_long)
							out[outposition++] =
								(char) (((leftoperand >> 8)^ eor) & 0xff);

						if (operand_is_long)
						{
							if (! CHECK_WORD_BOUNDS (leftoperand))
								error = OVERFLOW;
						}
						else
						{
							if (! CHECK_BYTE_BOUNDS (leftoperand))
								error = OVERFLOW;
						}	
					}
				}
			}
			bypassoperand = FALSE;
			break;

		case CHECK_OPERAND:
			if (operandstackpoint)
				error = BRACKET_ERROR;
			break;

		case IGNORE_SOURCECODE_LINE:
			if (GetNextLine(map) != OK) return OK;
			send_2 = RESET;
			break;

		case SKIP_IF_BLOCK:
			ifcounter++;
//			if (Search(map,endif_string,linenumber) != OK) 
//				return UNSOLVED_IF;
//			GetThisLine(map);
			preprocess_mode = AWAIT_ENDIF;
			break;

		case SWITCH_TO_ASSEMBLE_MODE:
			preprocess_mode = ASSEMBLE;
			GetThisLine(map);
			send_2 = RESET;
			if (!macro_counter) linenumber--;
			break;

		case BREAK_ASSEMBLING:
			return OK;
	}
	send = NO_SEND;

	if (warning != OK)
	{
		if (!first_pass)
		{
			//term << "\n WARNING in line " << linenumber << " : " << WarningTable[warning]
			//	<< " [\"" << map->filename << "\"]";
			term << "\n WARNING \""
				<< map->filename << "\"  " << linenumber << " : " << WarningTable[warning];
			
			warning_counter++;
		}
		warning = OK;
	}
		
	if (error != OK)
	{
		//assemblestatus = AWAIT_ENDOFLINE;
		//term << "\nHaben Error = " << error;
		if (hard_error || !first_pass || error == DOUBLE_DEFINITION || error == UNDEFINED_STATEMENT ||
				(assemblerlinetype == INSTRUCTION && instruction >= IF_INSTR && instruction < ENDIF_INSTR))
		{
			term << "\n ERROR \""
				<< map->filename << "\"  " << linenumber << " : " << ErrorTable[error];
			error_counter++;
			
			if (hard_error) return error; 
		}
		error = OK;
		send_2 = RESET;
		if (GetNextLine(map) != OK) return OK;

		/*	*message << "\n\n\n";
		message->close();
		return error;*/
	}

	}
}

int Assembler::Assemble(char* sourcefile)
{
	path = sourcefile;
	((path << str_end) >= str_end) <= ".";

	str term_path = path;
	term_path + ".err";
	term.open(term_path.ch());

	term << " *** MOS 6502 Cross Assembler [C64 TurboAss+ compatible] by Bernhard Burgstaller (C) 1998 ***\n";
	
	Map* map = OpenSourceFile(sourcefile);
	//map_root = map;
	if (! map->base)
	{
		term << "\n Cannot open file!";
		return 1;
	}

	char end_sourcefile[] = {13,10,'*','=','0',13,10,0};
	int c=0;
	while (end_sourcefile[c])
		map->base[map->length++] = end_sourcefile[c++];

	
	term << "\n first pass:";
	Flags hard_error = AssembleMap(map,TRUE);
/*	if (hard_error != OK)
	{
		term << "\n ** HARD ERROR : " << ErrorTable[hard_error] << " ** Assembling breaked";
	}
	else*/
	if (hard_error == OK)
	{
		//term << "\nEND FIRST PASS";
		//PrintLabels();

		term << "\n second pass:";
		//term << map->base;
		map->position = 0;
		hard_error = AssembleMap(map,FALSE);
	}

	if (hard_error != OK)
		//term << "\n ERROR \""
			//	<< map->filename << "\" " << linenumber << " : " << ErrorTable[error]
		//term << "\n ** HARD ERROR : " << ErrorTable[hard_error]
		term << " ** Assembling breaked";

	/*term << "\n MapList\n";
	while (map) {
		term << "\n"<< map << " len = " << map->length;
		int c=-1;
		while (++c < map->length) term << map->base[c];
		term <<"*";
		
		map = map->macro_caller_map; }
		*/

	char errcount[40];
	std::sprintf(errcount,"\n\n %ld  ERRORS \n %ld  WARNINGS",error_counter,warning_counter);
	term << errcount;
	
		//term << "\n\n"; PrintLabels();
	
	DeleteLabelTable();

	term.close();

/*
	if ((error_counter==0 && d_t_s->show_ass_res_errors_is_null)
		|| (error_counter>0 && d_t_s->show_ass_res_errors_greater_0))


		ShellExecute( NULL, 
 // handle to parent window 
 
	"open", 
 // pointer to string that specifies operation to perform 
 
	term_path.ch(), 
 // pointer to filename or folder name string 
 
	NULL, 
 // pointer to string that specifies executable-file parameters 
 
	"C:\\", 
 // pointer to string that specifies default directory 
 
	SW_SHOW 
 // whether file is shown when opened 
 
	); 
*/

//		term << "\nEND SEC PASS";
//	PrintLabels();
	//term << "\n Shellerror = " << shell.hInstApp;

	return error_counter;
}


//////////////////////////////////////////////////////////////////////
// Konstruktion/Destruktion
//////////////////////////////////////////////////////////////////////

Assembler::Assembler()
{
	error_counter = 0;
	warning_counter = 0;
}

Assembler::~Assembler()
{

}
